// MsgQueue.h : Declaration of the CMsgQueue

#ifndef __MSGQUEUE_H_
#define __MSGQUEUE_H_

#include "resource.h"       // main symbols
#include "atlqueuecp.h"

/////////////////////////////////////////////////////////////////////////////
// CMsgQueue
class ATL_NO_VTABLE CMsgQueue : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMsgQueue, &CLSID_MsgQueue>,
	public ISupportErrorInfo,
	public CProxy_IMsgQueueEvents< CMsgQueue >,
	public IConnectionPointContainerImpl<CMsgQueue>,
	public IDispatchImpl<IMsgQueue, &IID_IMsgQueue, &LIBID_ATLQUEUELib>
{
public:
	CMsgQueue();

DECLARE_REGISTRY_RESOURCEID(IDR_MSGQUEUE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMsgQueue)
	COM_INTERFACE_ENTRY(IMsgQueue)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CMsgQueue)
CONNECTION_POINT_ENTRY(DIID__IMsgQueueEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IMsgQueue
public:
	STDMETHOD(PostMessage)(short portNo);

	STDMETHOD(Advise)(IUnknown *pUnk, DWORD *pdwCookie);
};

#endif //__MSGQUEUE_H_
